//      _________________________________________
//_____/                                         \ 
//____/   coeur.js - paramétrages spécifiques     \ 
//    \___________________________________________/  
//
//

//Paramétrages de l'application
Affiche_titre_navigateur("La balance à calculer");

//Affiche le bandeau de titre
//Affiche_bandeau(abt)

//Variables pour les dimensions
var largConteneur=900;
//var hautConteneur=400;
var hautConteneur=273;
var wtot=document.body.offsetWidth;
var margeg=parseInt((wtot - largConteneur) / 2);
var deplacement=true;

//Variables pour les options
var change_option=false;

//Variables pour les sommes
var platoGauche=0;
var platoDroite=0;
var sommePlatoGauche="";
var sommePlatoDroite="";

//Variables pour les pages
//var page=""; var pagez=Recupere_GET("page"); if(pagez !== "")page=pagez;

//Variables pour les scores
var types_scores=new Array("objectif5","objectif10","chrono5","chrono10","minuteur1","minuteur2");
var nbcalculs=0; var nbcalculsz=Recupere_GET("nbcalculs"); if(nbcalculsz !== "")nbcalculs=nbcalculsz;
var nbreussites=0; var nbreussitesz=Recupere_GET("nbreussites"); if(nbreussitesz !== "")nbreussites=nbreussitesz;
var temps=0; var tempsz=Recupere_GET("temps"); if(tempsz !== "")temps=tempsz;
var chrono=0; var zechrono=null;
var dureemaxi=300; //5 minutes maxi de jeu chronométré

//Recherche du niveau
var niveau = "nb40";
var niveauz=Recupere_GET("niveau"); if(niveauz !== "")niveau=niveauz;
var mode = "entrainement";
var modez=Recupere_GET("mode"); if(modez !== "")mode=modez;
var score = "objectif5";
var scorez=Recupere_GET("score");if(scorez !== "")score=scorez;
var niveaux=new Array("points4","points13","nb4","nb13","nb40","nb121");

//var a = niveaux.indexOf(niveau);

//Centrer les div
Centre_element("bandeau");
Centre_element("parametres");
Centre_element("fond_conteneur");
Centre_element("conteneur");
Centre_element("options");
Centre_element("page");
Centre_element("consigne");
Centre_element("pied");

var popos1=document.getElementById("pied");
var popos2=document.getElementById("consigne");
var conteneur=document.getElementById("conteneur");

zoneXmin=conteneur.offsetLeft;
zoneXmax=(conteneur.offsetLeft + conteneur.offsetWidth);
zoneYmin=conteneur.offsetTop;
zoneYmax=(conteneur.offsetTop + conteneur.offsetHeight);

var zones = document.querySelector("#conteneur");
var activeItem = null;

var active = false;

zones.addEventListener("touchstart", dragStart, false);
zones.addEventListener("touchend", dragEnd, false);
zones.addEventListener("touchmove", drag, false);

zones.addEventListener("mousedown", dragStart, false);
zones.addEventListener("mouseup", dragEnd, false);
zones.addEventListener("mousemove", drag, false);


//Calcul de l'abscisse du premier poids selon le niveau
var nbPoids=0;
var largeurPoids=0;
var maxrand=0;
switch(niveau)
{
 case "nb4":nbPoids=2; largeurPoids=60; break;
 case "nb13":nbPoids=3; largeurPoids=60; break;
 case "nb40":nbPoids=4; largeurPoids=60; break;
 case "nb121":nbPoids=5; largeurPoids=60; break;
 case "points4":nbPoids=2; largeurPoids=50; break;
 case "points13":nbPoids=3; largeurPoids=50; break;
}
var decalagePoids=largeurPoids + 10;
var milieuZone=conteneur.offsetWidth / 2;
var xMin=milieuZone - (nbPoids * 50);

//Affiche les poids
if(niveau=="nb4" || niveau=="nb13" || niveau=="nb40" || niveau=="nb121")
{
 xPoids=xMin;
 var poids_1 = Cree_nombre("poids_1",1,"jaune",30,xPoids);
 xPoids=xPoids + 100;
 var poids_3 = Cree_nombre("poids_3",3,"jaune",30,xPoids);
 maxrand=4;

}

if(niveau=="nb13" || niveau=="nb40" || niveau=="nb121")
{
 xPoids=xPoids + 100;
 var poids_9 = Cree_nombre("poids_9",9,"jaune",30,xPoids);
 maxrand=13;
}

if(niveau=="nb40" || niveau=="nb121")
{
 xPoids=xPoids + 100;
 var poids_27 = Cree_nombre("poids_27",27,"jaune",30,xPoids);
 maxrand=40;
}

if(niveau=="nb121")
{
 xPoids=xPoids + 100;
 var poids_81 = Cree_nombre("poids_81",81,"jaune",30,xPoids);
 maxrand=121;
}

//Affiche les dominos
if(niveau=="points4" || niveau=="points13")
{
 xPoids=xMin;
 var poids_1 = Cree_domino("poids_1",1,"",30,xPoids);
 xPoids=xPoids + 100;
 var poids_3 = Cree_domino("poids_3",3,"",30,xPoids);
 maxrand=4;
}

if(niveau=="points13")
{
 xPoids=xPoids + 100;
 var poids_9 = Cree_domino("poids_9",9,"",30,xPoids);
 maxrand=13;
}

if(niveau!=null)
{
 //Calculer le nombre aléatoire
 var nb=Math.floor((Math.random() * maxrand) + 1);
 var plato=Math.floor((Math.random() * 2) + 1);
 lplato=530;
 if(plato==1)lplato=70;
}else{
 //Affiche_element("choisis_un_niveau");
 Cache_element("rejouer");
 Occulte_element("verifier");
}

if(niveau=="nb4" || niveau=="nb13" || niveau=="nb40" || niveau=="nb121")
{
 //Affiche le poids avec le nombre aléatoire
 hasard = Cree_nombre("hasard",nb,"orange",212,lplato);
}

if(niveau=="points4" || niveau=="points13")
{
 //nb=13;
 var nb1=nb;
 var nb2=0;
 if(nb==13){nb1=12; nb2=1;}
 var hasard = Cree_domino("hasard",nb1,"orange",172,lplato);

 if(nb==13)
 {
  var hasard1 = Cree_domino("hasard1",nb2,"orange",172,lplato + 60);
 }
}

//Affiche la balance non active
var balance = document.createElement("IMG");
balance.src = "./ressources/balance_desactivee.png";
balance.style.width="836px"; 
balance.style.height="136px"; 
balance.style.top="230px"; 
balance.style.left="32px"; 
balance.style.position="absolute"; 
balance.style.zIndex="-1"; 
balance.id="balance"; 
zones.appendChild(balance);

//Affiche les paramètres du jeu
Affiche_parametres_jeu();
Regenere_barre_progression();

//Chronomètre ou minuteur ?
zz=types_scores.indexOf(score);
if(zz>1) 
{
 chrono=temps;
 Demarre_temps();
 if(zz==4)dureemaxi=60; 
 if(zz==5)dureemaxi=120; 
}

