//      ____________________________________
//_____/                                    \ 
//____/   plus.js - fonctions spécifiques   \ 
//    \______________________________________/  
//
//

//Paramètres globaux
poids=new Array();
poids[1]="1,3,9";

//Fonctions

function Cree_nombre(cn_id,cn_nb,cn_couleur,cn_top,cn_left)
{
 var cn = document.createElement("DIV");
 cn.id=cn_id;

 cn.style.top=cn_top + "px";
 cn.style.left=cn_left + "px";

 cn.style.fontWeight="bold";
 cn.style.textAlign="center";
 cn.style.fontSize="25px";
 cn.style.lineHeight="60px";
 cn.style.borderRadius="10px";

 cn.nb=cn_nb;
 cn.plateau="";
 cn.innerHTML=cn_nb;

 bgcol="jaune";
 cn.className="item nombre jaune";
 if(cn_couleur=="orange")
 {
  bgcol="orange";
  cn.className="nombre orange";
  cn.zIndex=-2;
 }

 zones.appendChild(cn);
 return(cn); 
}

function Cree_domino(cn_id,cn_nb,cn_couleur,cn_top,cn_left)
{
 var cn = document.createElement("IMG");
 cn.id=cn_id;
 var h="";
 cn.className="item";
 if(cn_couleur=="orange")
 {
  h="h";
  cn.style.cursor="default";
 }
 cn.src = "./ressources/dominos_"+h+cn_nb+".png";

 cn.style.width="50px"; 
 cn.style.height="100px"; 
 cn.style.top=cn_top + "px";
 cn.style.left=cn_left + "px";
 cn.zIndex="-3";

 cn.nb=cn_nb;
 cn.plateau="";

 zones.appendChild(cn);
 return(cn); 
}

function Info(tt)
{
 Cache_element("bouton_info");
 Cache_element("bouton_options");
 Cache_element("bouton_rejouer");
 Cache_element("bouton_verifier");
 var ttx="";
 var titrepage="titre_informations";
 if(tt=="ml") {ttx="ml_"; titrepage="titre_ml";}
 document.getElementById("titre_page").src="./ressources/"+titrepage+".png";
 document.getElementById("texte").src="./ressources/"+ttx+"balacal.html";
 Affiche_element("page");
 Affiche_element("bouton_annuler");
 Desocculte_element("bouton_annuler");
 Affiche_element("titre_page");
 Desocculte_element("titre_page");
}

function Fermer_page()
{
 Affiche_element("bouton_info");
 Affiche_element("bouton_options");
 Affiche_element("bouton_rejouer");
 Affiche_element("bouton_verifier");
 //Affiche_element("conteneur");
 Cache_element("page");
 Cache_element("bouton_annuler");
 document.getElementById("titre_page").src="";
 //niveau="";
}

function Rejouer()
{
 document.location.href="./index.html?niveau="+niveau+"&mode="+mode+"&score="+score+"&nbcalculs="+nbcalculs+"&nbreussites="+nbreussites+"&temps="+chrono;
}

function isset (accessor) {
  try {
    // Note we're seeing if the returned value of our function is not
    // undefined
    return typeof accessor() !== 'undefined'
  } catch (e) {
    // And we're able to catch the Error it would normally throw for
    // referencing a property of undefined
    return false
  }
}

function Verifie_ordonnee(vo)
{
 //Seulement si l'objet est défini
 if(typeof vo !=="undefined")
 {
  //Limites inférieure et supérieure différentes si nombres ou dominos
  var yMin=90; var yMax=220;
  if(niveau.substr(0,2)=="nb"){var yMin=135; var yMax=200;}
  //Position initiale
  var yp=coordNb(vo.style.top);
  //L'objet a bougé ? Position actuelle
  var z=vo.yOffset; 
  if(typeof z !=="undefined")yp=z;
  //Entre les bornes ?
  if(yp<yMin || yp>yMax) 
  {
   vo.style.display="none";
  }
 }
}

function Verifie_abscisse_gauche(vg)
{
 //Seulement si l'objet est défini
 if(typeof vg !=="undefined")
 {
  if(vg.style.display!="none")
  {
   //Limites inférieure et supérieure différentes si nombres ou dominos
   var xMin=15; var xMax=380;
   if(niveau.substr(0,2)=="nb"){var xMin=20; var xMax=380;}
   //Position initiale
   var xp=coordNb(vg.style.left);
   //L'objet a bougé ? Position actuelle
   var z=vg.xOffset; 
   if(typeof z !=="undefined")xp=xp+z;
   //Entre les bornes ?
   if(xp>xMin && xp<xMax) 
   {
	platoGauche = platoGauche + vg.nb; 
	var plus=""; if(sommePlatoGauche != "")plus=" + ";
	sommePlatoGauche = sommePlatoGauche + plus + vg.nb; 
	vg.plateau="G";
    if(vg.nb==12 && typeof hasard1 !=="undefined") 
    {
	 hasard1.plateau="G";
     platoGauche = platoGauche + 1; 
    }
   }
  }
 }
}

function Verifie_abscisse_droite(vd)
{
 //Seulement si l'objet est défini
 if(typeof vd !=="undefined")
 {
  if(vd.style.display!="none")
  {
   //Limites inférieure et supérieure différentes si nombres ou dominos
   var xMin=480; var xMax=850;
   if(niveau.substr(0,2)=="nb"){var xMin=480; var xMax=840;}
   //Position initiale
   var xp=coordNb(vd.style.left);
   //L'objet a bougé ? Position actuelle
   var z=vd.xOffset; 
   if(typeof z !=="undefined")xp=xp+z;
   //Entre les bornes ?
   if(xp>xMin && xp<xMax) 
   {
	platoDroite = platoDroite + vd.nb; 
	var plus=""; if(sommePlatoDroite != "")plus=" + ";
	sommePlatoDroite = sommePlatoDroite + plus + vd.nb; 
	vd.plateau="D";
    if(vd.nb==12 && typeof hasard1 !=="undefined") 
    {
	 hasard1.plateau="D";
     platoDroite = platoDroite + 1; 
    }
   }
  }
 }
}

function Positionne_poids(vo)
{
 //Seulement si l'objet est défini
 if(typeof vo !=="undefined")
 {
  bas=80;  
  if(vo.id=="hasard"){bas="444"}
  haut=bas - 38;
  if(vo.id=="hasard" && niveau.substr(0,2)=="po"){bas="364";haut=bas-38;}
  if(vo.plateau=="G")
  {
   if(platoGauche > platoDroite) vo.style.top=(bas - coordNb(vo.style.top))+"px";
   if(platoGauche < platoDroite) vo.style.top=(haut - coordNb(vo.style.top))+"px";
  }
  if(vo.plateau=="D")
  {
   if(platoGauche < platoDroite) vo.style.top=(bas - coordNb(vo.style.top))+"px";
   if(platoGauche > platoDroite) vo.style.top=(haut - coordNb(vo.style.top))+"px";
  }
  if(vo.plateau!="D" && vo.plateau!="G")vo.style.display="none";
  if(typeof hasard1 !=="undefined") hasard1.style.top=hasard.style.top;
 }
}


function Affiche_bouton_option(cn_id,cn_img,cn_txt,cn_fond,cn_actif,cn_top,cn_left)
{
 var cn = document.createElement("DIV");
 cn.id=cn_id;
 cn.style.top=cn_top + "px";
 cn.style.left=cn_left + "px";
 cn.style.textAlign="center";
 cn.style.fontSize="14px";
 cn.style.lineHeight="20px";
 cn.style.borderRadius="15px";
 cn.style.padding="5px";
 cn.style.backgroundColor=cn_fond;
 var cnimg="";
 if(cn_img!="")cnimg='<img src="./ressources/'+cn_img+'.png" style="position:relative;top:5px;height:30px;"> ';
 cn.innerHTML="&nbsp;"+cnimg+'<span style="position:relative;top:-5px;">'+cn_txt+'</span>'+"&nbsp;";
 cn.className="bouton_option_OFF";
 if(cn_actif=="titre")cn.className="bouton_option_TITRE";
 options.appendChild(cn);
 return(cn); 
}

function Options()
{
 Cache_element("bouton_info");
 Cache_element("bouton_options");
 Cache_element("bouton_rejouer");
 Cache_element("bouton_verifier");
 document.getElementById("titre_page").src="./ressources/titre_parametres.png";
 Affiche_element("bouton_ok");
 Affiche_element("options");
 Affiche_option("niveau_"+niveau,true);
 Affiche_option("mode_"+mode,true);
 if(mode=="competition")
 {
  Affiche_element("option_score");
  Affiche_option("score_"+score,true);
 }else{Cache_element("option_score");}
}

function Affiche_option(ao_option,ao_valeur)
{
 var ao_o=document.getElementById(ao_option);
 var ao_c="option_OFF";
 if(ao_valeur==true) ao_c="option_ON";
 ao_o.className=ao_c;
 var ao_rubrique=ao_option.split("_");
 switch(ao_rubrique[0])
 { 
  case"niveau":niveau=ao_rubrique[1];break;
  case"mode":mode=ao_rubrique[1];break;
  case"score":score=ao_rubrique[1];break;
 }
 if(mode=="competition")
 {
  Affiche_element("option_score");
 }else{Cache_element("option_score");}
}

function Ok()
{
 Affiche_element("bouton_info");
 Cache_element("options");
 Affiche_element("bouton_options");
 Affiche_element("bouton_rejouer");
 Affiche_element("bouton_verifier");
 Cache_element("bouton_ok");
 document.getElementById("titre_page").src="";
 if(change_option)
 {
  document.location.href="./index.html?niveau="+niveau+"&mode="+mode+"&score="+score+"&nbcalculs=0&nbreussites=0&temps=0";
 }
}

function Change_option(co_rubrique,co_option)
{
 var co_temp1=document.getElementById(co_rubrique+"_"+co_option).className;
 switch(co_rubrique)
 {
  case "niveau":
   Affiche_option("niveau_points4",false);
   Affiche_option("niveau_points13",false);
   Affiche_option("niveau_nb4",false);
   Affiche_option("niveau_nb13",false);
   Affiche_option("niveau_nb40",false);
   Affiche_option("niveau_nb121",false);
  break;
  case "mode":
   Affiche_option("mode_entrainement",false);
   Affiche_option("mode_competition",false);
  break;
  case "score":
   Affiche_option("score_objectif5",false);
   Affiche_option("score_objectif10",false);
   Affiche_option("score_chrono5",false);
   Affiche_option("score_chrono10",false);
   Affiche_option("score_minuteur1",false);
   Affiche_option("score_minuteur2",false);
 }
 Affiche_option(co_rubrique+"_"+co_option,true);
 var co_temp2=document.getElementById(co_rubrique+"_"+co_option).className;
 if(co_temp1!=co_temp2)change_option=true;
 if(mode=="competition")  document.getElementById("score_"+score).className="option_ON";

}

function Affiche_parametres_jeu()
{
 var bouton_niveau="";
 switch(niveau)
 {
  case "points4":bouton_niveau="constellations jusqu'à 4";break;
  case "points13":bouton_niveau="constellations jusqu'à 13";break;
  case "nb4":bouton_niveau="nombre jusqu'à 4";break;
  case "nb13":bouton_niveau="nombres jusqu'à 13";break;
  case "nb40":bouton_niveau="nombres jusqu'à 40";break;
  case "nb121":bouton_niveau="nombres jusqu'à 121";break;
 }
 var bouton_mode="";
 switch(mode)
 {
  case "entrainement":bouton_mode="entraînement";break;
  case "competition":bouton_mode="compétition";break;
 }
 var bouton_score="pas de calcul de score";
 if(mode=="competition")
 {
  switch(score)
  {
   case "objectif5":bouton_score="réussir 5 calculs sans limite de temps";break;
   case "objectif10":bouton_score="réussir 10 calculs sans limite de temps";break;
   case "chrono5":bouton_score="réussir 5 calculs le plus vite possible";break;
   case "chrono10":bouton_score="réussir 10 calculs le plus vite possible";break;
   case "minuteur1":bouton_score="réussir le plus possible de calculs en 1 minute";break;
   case "minuteur2":bouton_score="réussir le plus possible de calculs en 2 minutes";break;
  }
 }
 document.getElementById("parametres_jeu").innerHTML="Paramètres du jeu : "+bouton_niveau+" - "+bouton_mode+" - "+bouton_score+"<br><br>";

}

function Verifier()
{
 //Vérification des coordonnées de chaque élément (nombres ou dominos) selon le niveau
 //et construction des sommes de chaque plateau
 
 //Vérification de la présence des objets aux alentours d'un des plateaux
 // environ 150-220 en ordonnée
 // environ 10-380 en abscisse pour le plateau de gauche
 // environ 48-850 en abscisse pour le plateau de droite

 //Cacher le bouton de validation
 Occulte_element("bouton_verifier");
 //Occulte_element("bouton_info");
 Occulte_element("bouton_options");

 //Oblitérer le déplacement
 deplacement=false;

 //Réinitialisation variables
 platoGauche=0;
 platoDroite=0;

 //Élimine ceux qui sont trop haut ou trop bas
 Verifie_ordonnee(poids_1);
 Verifie_ordonnee(poids_3);
 Verifie_ordonnee(poids_9);
 Verifie_ordonnee(poids_27);
 Verifie_ordonnee(poids_81);

 //Comptabilise ceux qui sont sur le plateau de gauche
 Verifie_abscisse_gauche(hasard);
 Verifie_abscisse_gauche(poids_1);
 Verifie_abscisse_gauche(poids_3);
 Verifie_abscisse_gauche(poids_9);
 Verifie_abscisse_gauche(poids_27);
 Verifie_abscisse_gauche(poids_81);
 
 //Comptabilise ceux qui sont sur le plateau de droite
 Verifie_abscisse_droite(hasard);
 Verifie_abscisse_droite(poids_1);
 Verifie_abscisse_droite(poids_3);
 Verifie_abscisse_droite(poids_9);
 Verifie_abscisse_droite(poids_27);
 Verifie_abscisse_droite(poids_81);
 
 //Vérifie égalité des plateaux
 if(platoGauche > platoDroite) nomBalance="balance_gauche";
 if(platoGauche < platoDroite) nomBalance="balance_droite";
 if(platoGauche == platoDroite) nomBalance="balance_centre";

 //Affichage balance adéquate
 document.getElementById("balance").src="./ressources/" + nomBalance + ".png";
 
 //Monte ou descend les poids selon position du plateau
 Positionne_poids(hasard);
 Positionne_poids(poids_1);
 Positionne_poids(poids_3);
 Positionne_poids(poids_9);
 Positionne_poids(poids_27);
 Positionne_poids(poids_81);

 //Affiche le message d'évaluation
 if(nomBalance=="balance_centre")
 {
  var z=document.getElementById("message_bravo");
  var sosomme=platoDroite;
  if(sommePlatoGauche==platoGauche)sosomme="";
  if(sommePlatoDroite==platoDroite)sosomme="";
  if(sosomme!="")sosomme=" = "+sosomme;
  z.innerHTML=z.innerHTML+"<br>"+sommePlatoGauche+" = "+sommePlatoDroite+sosomme;
  Affiche_element("bravo");
 }else{
  var z=document.getElementById("message_oups");
  if(Math.round(platoGauche)<Math.round(platoDroite))
  {
   z.innerHTML=z.innerHTML+"<br>"+ sommePlatoGauche+" < "+sommePlatoDroite;
   if((sommePlatoGauche+" < "+sommePlatoDroite)!==(platoGauche+" < "+platoDroite))z.innerHTML=z.innerHTML+"<br>"+platoGauche+" < "+platoDroite;
  }  
  if(Math.round(platoGauche)>Math.round(platoDroite))
  {
   z.innerHTML=z.innerHTML+"<br>"+ sommePlatoGauche+" > "+sommePlatoDroite;
   if((sommePlatoGauche+" > "+sommePlatoDroite)!==(platoGauche+" > "+platoDroite))z.innerHTML=z.innerHTML+"<br>"+platoGauche+" > "+platoDroite;
  }
  Affiche_element("oups");
 }
 
 //Incrémente les compteurs de calculs/réussites/temps
 nbcalculs++;
 if(nomBalance=="balance_centre")nbreussites++;
 if(mode=="entrainement")
 {
 }
 Regenere_barre_progression();
 if(mode=="competition")
 {
  if((score=="objectif5" && nbreussites>=5) || (score=="objectif10" && nbreussites>=10))
  {
   var z=document.getElementById("message_reussi");
   z.innerHTML="Bravo !!!<br>Tu as atteint ton objectif : "+nbreussites+" réussites !";
   Affiche_element("reussi");
   nbreussites=0;
   nbcalculs=0;
  }
  if((score=="chrono5" && parseInt(nbreussites)>=5) || (score=="chrono10" && parseInt(nbreussites)>=10))
  {
   Stop_chrono();
   if(nbreussites>0)
   {
    var z=document.getElementById("message_reussi");
    z.innerHTML="Bravo !!!<br>Tu as obtenu "+nbreussites+" réussites en "+chrono+" sec !";
    Affiche_element("reussi");
   }else{
    var z=document.getElementById("message_depasse");
    z.innerHTML="Heu...<br>Aucune réussite en "+chrono+" sec...";
    Affiche_element("depasse");
   }
   document.getElementById("chrono").innerHTML=chrono;
   nbreussites=0;
   nbcalculs=0;
   temps=0;
   chrono=0;
  }
 }
}

function Regenere_barre_progression()
{
 barreprog11='';
 barreprog21='';
 if(score=="chrono5" | score=="chrono10" || score=="minuteur1" || score=="minuteur2")    
 {

  var tititre="temps";
  barreprog11='<div class="compteur_titre bleu">'+tititre+'</div>';
  barreprog21='<div class="compteur bleu" id="chrono">'+chrono+'</div>';
 }
  barreprog1='<div class="compteur_titre blanc">calculs</div><div class="compteur_titre vert">réussis</div><div class="compteur_titre rouge">loupés</div>'+barreprog11+'<div class="clear">';
  barreprog2='<div class="compteur blanc">'+nbcalculs+'</div><div class="compteur vert">'+nbreussites+'</div><div class="compteur rouge">'+(nbcalculs-nbreussites)+'</div>'+barreprog21;
  document.getElementById("barre_progression").innerHTML=barreprog1+barreprog2;
}

function Temps_depasse()
{
 Stop_chrono();
 deplacement=false;
 Occulte_element("bouton_info");
 Cache_element("bouton_annuler");
 Occulte_element("bouton_annuler");
 Occulte_element("bouton_options");
 Affiche_element("bouton_verifier");
 Occulte_element("bouton_verifier");
 Occulte_element("bouton_ok");
 Affiche_element("bouton_rejouer");
 Cache_element("options");
 Cache_element("page");
 Cache_element("titre_page");
 if(score.substr(0,6)=="chrono")
 {
  var z=document.getElementById("message_depasse");
  z.innerHTML="Oooooh !!!<br>La durée maxi de 5 minutes<br>est écoulée !";
  Affiche_element("depasse");
 }
 if(score.substr(0,8)=="minuteur")
 {
  var plur="s"; var nbmin=2;
  if(score=="minuteur1"){plur="";nbmin=1;}

  if(nbreussites>0)
  {
   var z=document.getElementById("message_reussi");
   z.innerHTML="Bravo !!!<br>Tu as obtenu "+nbreussites+" réussites en "+nbmin+" minute"+plur+" !";
   Affiche_element("reussi");
  }else{
   var z=document.getElementById("message_depasse");
   z.innerHTML="Heu...<br>Aucune réussite en "+nbmin+" minute"+plur+" ?";
   Affiche_element("depasse");
  }

 }
 document.getElementById("chrono").innerHTML=chrono;
 nbreussites=0;
 nbcalculs=0;
 temps=0;
 chrono=0;
}

function Demarre_temps()
{
 zechrono=setInterval(function(){
	 chrono++; 
	 document.getElementById("chrono").innerHTML=chrono;
	 if(chrono>=dureemaxi)Temps_depasse();
	 }, 1000);
}

function Stop_chrono()
{
 clearInterval(zechrono);
}
